/*
 * public functions
 */

(function($){
	$.sp = $.sp || {};

	Number.prototype.qtoFixed = function(d)
	{
	var s=this+"";if(!d)d=0;
	if(s.indexOf('e')!=-1)return parseFloat(s).toFixed(d);
	if(s.indexOf(".")==-1)s+=".";s+=new Array(d+1).join("0");
	if (new RegExp("^(-|\\+)?(\\d+(\\.\\d{0,"+ (d+1) +"})?)\\d*$").test(s))
	{
	var s="0"+ RegExp.$2, pm=RegExp.$1, a=RegExp.$3.length, b=true;
	if (a==d+2){a=s.match(/\d/g); if (parseInt(a[a.length-1])>4)
	{
	for(var i=a.length-2; i>=0; i--) {a[i] = parseInt(a[i])+1;
	if(a[i]==10){a[i]=0; b=i!=1;} else break;}
	}
	s=a.join("").replace(new RegExp("(\\d+)(\\d{"+d+"})\\d$"),"$1.$2");
	}if(b)s=s.substr(1);return (pm+s).replace(/\.$/, "");} return this+"";
	};

	$.sp.fmoney=function (s, n,un)  {
		var   erg=/^(-?\d+)(\.\d+)?$/;
		if(erg.test(s)){
			n = n > 0 && n <= 20 ? n : 2;
			if(un) s = (s + "").replace(/[^\d\.-]/g, "");
			else s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).qtoFixed(n) + "";
			var fs=s;
			if(parseFloat(s)<0) s=s.slice(1);
			var l = s.split(".")[0].split("").reverse();
			r = s.split(".")[1];
			var joinpoint=null;
			if(r==undefined) joinpoint='';
			else  joinpoint="." + r;
			t = "";
			for(var i = 0; i < l.length; i ++ )
			{
			   t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
			}

			var result=t.split("").reverse().join("") + joinpoint;
			if(parseFloat(fs)>=0)  return result;
			else return '-'+result;
		}
		else return '';
	};

	$.sp.rmoney=function (s,un){
		if(s!=''){
			if(un)return (s + "").replace(/[^\d\.-]/g, "");
			else return parseFloat((s + "").replace(/[^\d\.-]/g, ""));
		}
		else return '';
	};
	
	/**
	 * 转换日期的格式
	 * @param yyyymmdd/yyyymmddhhmmss
	 */
	$.sp.formateDate = function(date ,formate){
		if(date!=null && date!=''){
			if(formate == 'yyyy-mm-dd'){
				return date.substring(0,4)+'-'+date.substring(4,6)+'-'+date.substring(6,8);
			}else if(formate == 'yyyy-mm-dd hh:mm:ss'){
				if(date.length == 14){
					return date.substring(0,4)+'-'+date.substring(4,6)+'-'+date.substring(6,8)+' '+date.substring(8,10)+':'+date.substring(10,12)+':'+date.substring(12,14);
				}else{
					return '';
				}
			}
		}else return '';
	};
	
	/**
	 * 获取当前的时间
	*/ 
	$.sp.getCurDate = function() {
		var date = new Date();
		var month = date.getMonth() + 1;
		var day = date.getDate();
		if(month >=1 && month <= 9){
			month = '0' + month;
		}
		if(day >= 0 && day <= 9){
			day = '0' + day;
		}
		return date.getFullYear()+'-'+month+'-'+day+' '+date.getHours()+':'+date.getMinutes()+':'+date.getSeconds();
	}; 
	
	/**日期加上天数得到新的日期  
	*dateTemp 需要参加计算的日期，days要添加的天数，返回新的日期，日期格式：YYYY-MM-DD 
	*/ 
	$.sp.getNewDay = function(dateTemp, days) {
		if(dateTemp != null && dateTemp!= '' && dateTemp!= 'undefined'){
		    var nDate = new Date(parseISO8601(dateTemp));
		    var millSeconds = Math.abs(nDate) + (parseInt(days) * 24 * 60 * 60 * 1000);  
		    var rDate = new Date(millSeconds);  
		    var year = rDate.getFullYear();  
		    var month = rDate.getMonth() + 1;  
		    if (month < 10) month = "0" + month;  
		    var date = rDate.getDate();  
		    if (date < 10) date = "0" + date;  
		    return (year + "-" + month + "-" + date); 
		}
	}; 

	/**Parses string formatted as YYYY-MM-DD to a Date object.
	 * If the supplied string does not match the format, an
	 * invalid Date (value NaN) is returned.
	 * @param {string} dateStringInRange format YYYY-MM-DD, with year in
	 * range of 0000-9999, inclusive.
	 * @return {Date} Date object representing the string.
	 */
	function parseISO8601(dateStringInRange) {
	  var isoExp = /^\s*(\d{4})-(\d\d)-(\d\d)\s*$/,
	      date = new Date(NaN), month,
	      parts = isoExp.exec(dateStringInRange);
	
	  if(parts) {
	    month = +parts[2];
	    date.setFullYear(parts[1], month - 1, parts[3]);
	    if(month != date.getMonth() + 1) {
	      date.setTime(NaN);
	    }
	  }
	  return date;
	}
	
	$.sp.getScreenSize = function() {
		var size = {};
		var windowHeight = $(window).height() - $('body').heightEx();
		var windowWidth = $(window).width() - $('body').widthEx();
		var LtopHeight = $('#Ltop-fixed').outerHeight(true);
		var LbottomHeight = $('#Lbottom-fixed').outerHeight(true);
		$('#Lscroll-wrap').height(windowHeight - LtopHeight - LbottomHeight - $('#Lscroll-wrap').heightEx());
		if(windowHeight > windowWidth) {
			size.height = $('#Lscroll-wrap').height() / 4 - $('#Lscroll-wrap>div').heightEx();
			size.width = $('#Lscroll-wrap').width() / 2 - $('#Lscroll-wrap>div').widthEx();
		} else {
			size.height = $('#Lscroll-wrap').height() / 2 - $('#Lscroll-wrap>div').heightEx();
			size.width = $('#Lscroll-wrap').width() / 4 - $('#Lscroll-wrap>div').widthEx();
		}
		return size;
	};
	
	$.sp.calculationFiles = function(files) {
		var obj = {};
		var size = 0;
		obj.num = files.length;
		$.each(files, function(k,v){
			// 计算得到文件总大小
			size += v.attchmentSize;
		});
		// 转化为kb和MB格式。文件的名字、大小、类型都是可以现实出来。
		if (size > 1024 * 1024) {                    
			size = (Math.round(size * 100 / (1024 * 1024)) / 100).toString() + 'MB';                
		} else {                    
			size = (Math.round(size * 100 / 1024) / 100).toString() + 'KB';                
		}  
		obj.size = size;
		return obj;
	};
})(jQuery);	